<?php

namespace Odhen\API\Service;

class Consumidor {
	
	protected $entityManager;
	protected $util;

	public function __construct(
		\Doctrine\ORM\EntityManager $entityManager,
		\Odhen\API\Util\Util $util)  {
			
		$this->entityManager = $entityManager;
		$this->util          = $util;
	}
	/**
	 * [populaDadosConsumidor description]
	 * @param  [array] $dadosConsumidor [description]
	 * @return [array] retorna um array com os dados completo do consumidor [description]
	 */
	public function populaDadosConsumidor($dadosConsumidor) {

		$params = array(
			':CDCONSUMIDOR' => $dadosConsumidor['CDCONSUMIDOR'],
			':CDCLIENTE' => $dadosConsumidor['CDCLIENTE']
		);
	    $dadosConsumidor = $this->entityManager->getConnection()->fetchAssoc(self::GET_CONSUMER_BY_ID, $params);
	    return $dadosConsumidor;
	}
	const GET_CONSUMER_BY_ID = "
		SELECT CO.CDCONSUMIDOR, CO.NRCPFRESPCON, CO.CDCLIENTE,
			   CO.NMCONSUMIDOR, CO.DSEMAILCONS, TO_CHAR(CO.DTNASCCONS, 'DD/MM/YYYY') AS DTNASCCONS, 
			   CO.IDSEXOCONS, CO.IDSITCONSUMI AS IDATIVO, CO.NRCEPCONS, CO.DSENDECONS, CO.NRENDECONS, 
			   MU.CDMUNICIBGE, MU.CDMUNICIPIO, CO.SGESTADO, PA.NMPAIS, CO.DSCOMPLENDECONS, PA.CDPAIS,
			   BA.NMBAIRRO, CO.NRTELECONS, CO.NRCELULARCONS, 1 AS ISPRINCIPAL, BA.CDBAIRRO, CO.DSREFERENDECONS
		
		  FROM CONSUMIDOR CO
		 
		 LEFT JOIN PAIS PA
		    ON CO.CDPAIS      = PA.CDPAIS
		    
		  LEFT JOIN BAIRRO BA
		    ON CO.CDPAIS      = BA.CDPAIS
		   AND CO.SGESTADO    = BA.SGESTADO
		   AND CO.CDMUNICIPIO = BA.CDMUNICIPIO
		   AND CO.CDBAIRRO    = BA.CDBAIRRO
		   
		LEFT JOIN MUNICIPIO MU
		    ON CO.CDPAIS      = MU.CDPAIS
		   AND CO.SGESTADO    = MU.SGESTADO
		   AND CO.CDMUNICIPIO = MU.CDMUNICIPIO
		
		 WHERE CDCONSUMIDOR = :CDCONSUMIDOR
		 AND CDCLIENTE = :CDCLIENTE
	";

}