function DashboardController($scope, $timeout, ScreenService, templateManager) {

	var widget = $scope.widget || templateManager.container;
	// Floating Control defaults
	var floatingControlDefaults = {
		pdfAction: false,
		xlsAction: false,
		customizationAction: {
			filter: false,
			layout: false,
			view: false
		}
	};
	widget.floatingControl = widget.floatingControl !== false && Util.extend(floatingControlDefaults, widget.floatingControl || {});

	this.itemClick = function(widget) {
		if (widget) {
			var event;
			if(widget.onDashboardClick) {
				event = widget.onDashboardClick();
			}
			if ((!event || !event.isDefaultPrevented()) && widget.windowName) {
				ScreenService.openWindow(widget.windowName);
			}
		}
	};

	this.itemConfigClick = function(widget) {
		if (widget) {
			var event;
			if(widget.onDashboardConfigClick) {
				event = widget.onDashboardConfigClick();
			}
		}
	};
}