function GraphingController(templateManager, ScreenService, GraphingService, ExtractService, LoginRepository, ProductGroupRepository, ProductGroupNutriRepository){

    this.setDefaultPeriods = function(widget){
        var date = new Date();

        var day = date.getDate();
        var actualMonth = date.getMonth() + 1; /* Months here are zero-based, so we add 1 to them. */
        var year = date.getFullYear();

        //if (widget.endDate.length == 0) widget.endDate = day + '/' + actualMonth + '/' + year; /* End date. */
        //--- TEMPORÁRIO
        if (widget.endDate.length == 0) widget.endDate = '01/01/2015'; /* End date. */
        var lastMonth = actualMonth - 1;
        if (lastMonth === 0){
            /* In case the actual month is January. */
            lastMonth = 12;
            year -= 1;
        }
        //if (widget.startDate.length == 0) widget.startDate = day + '/' + lastMonth + '/' + year; /* Start date. */
        //--- TEMPORÁRIO
        if (widget.startDate.length == 0) widget.startDate = '01/01/2014'; /* Start date. */
    };

    this.setDefaultPeriod = function(widget){
        var stripeWidget = templateManager.container.getWidget('stripe');
        var date = new Date();

        var finalDateInMoment = moment(date);
        var initialDateInMoment = moment(date).subtract(1,'months');

        var finalDateToString = finalDateInMoment.format('DD/MM/YYYY');
        var initialDateToString = initialDateInMoment.format('DD/MM/YYYY');

        if (widget.endDate.length == 0) widget.endDate = finalDateToString; /* End date. */
        if (widget.startDate.length == 0) widget.startDate = initialDateToString; /* Start date. */

        widget.container.getWidget('stripe').getField('DTFIM').label = widget.endDate;
        widget.container.getWidget('stripe').getField('DTINI').label = widget.startDate;
    };

    this.drillDown = function(widget, code, nextLevel){
        // var stripeWidget = templateManager.container.getWidget('stripe');
        // LoginRepository.findOne().then(function (consumerData){
        //     if (nextLevel === 'GROUPS'){
        //         GraphingService.getGroupedProducts(consumerData['CDCLIENTE'], consumerData['CDCONSUMIDOR'], widget.startDate, widget.endDate).then(function (groupedProducts){
        //             stripeWidget.actions[2].isVisible = false;
        //             stripeWidget.actions[3].isVisible = false;
        //             stripeWidget.getField('mediaGastoDiaria').label = parseFloat(groupedProducts['ValuesRepository'][2].VALUE.replace(",",".")).toFixed(2).replace(".",",");
        //             if (groupedProducts['ProductGroupRepository'].length){
        //                 widget.dataSource.data = groupedProducts['ProductGroupRepository'];
        //                 widget.labelField = 'NMGRUPPROD';
        //                 widget.valueField = 'VRTOTALPROD';
        //                 widget.nextLevel = "SUBGROUPS";
        //                 templateManager.updateTemplate();
        //             }
        //             else{
        //                 widget.dataSource.data = [];
        //                 ProductGroupRepository.clearAll().then(function(){
        //                     templateManager.updateTemplate();
        //                 }.bind(this));

        //             }

        //         }.bind(this));
        //     }
        //     else if (nextLevel === 'SUBGROUPS'){
        //         if (code == null){
        //             var code = {};
        //             code.CDGRUPPROD = null;
        //         }
        //         GraphingService.getSubgroups(consumerData['CDCLIENTE'], consumerData['CDCONSUMIDOR'], widget.startDate, widget.endDate, code.CDGRUPPROD).then(function (subgroups){
        //             stripeWidget.actions[2].isVisible = true;
        //             stripeWidget.actions[3].isVisible = false;
        //             widget.dataSource.data = subgroups;
        //             widget.labelField = 'NMSUBGRPROD';
        //             widget.valueField = 'VRTOTALPROD';
        //             widget.nextLevel = 'PRODUCTS';
        //             templateManager.updateTemplate();
        //         });
        //     }
        //     else if (nextLevel === 'PRODUCTS'){
        //         GraphingService.getProducts(consumerData['CDCLIENTE'], consumerData['CDCONSUMIDOR'], widget.startDate, widget.endDate, code.CDGRUPPROD, code.CDSUBGRPROD).then(function (subgroups){
        //             stripeWidget.actions[2].isVisible = false;
        //             stripeWidget.actions[3].isVisible = true;
        //             widget.dataSource.data = subgroups;
        //             widget.labelField = 'NMPRODUTO';
        //             widget.valueField = 'VRTOTALPROD';
        //             widget.nextLevel = null;
        //             templateManager.updateTemplate();
        //         });
        //     }
        // }.bind(this));
    };

    this.openPeriodSelect = function(widget){
        var financialVisionWidget = widget.parent;
        var dataInicial = widget.fields[0];
        var dataFinal = widget.fields[1];
        var currentDate = new Date();
        var maxDate = currentDate.getFullYear() + '-' + (currentDate.getMonth()+1) + '-' + currentDate.getDate();

        dataInicial['datetime-maxDate'] = maxDate;
        dataFinal['datetime-maxDate'] = maxDate;
        dataInicial['datetime-defaultDate'] = currentDate.getFullYear()-1 + '-01-01 23:59';
        dataFinal['datetime-defaultDate'] = currentDate.getFullYear()-1 + '-01-01 23:59';
        dataInicial.setValue(financialVisionWidget.startDate);
        dataFinal.setValue(financialVisionWidget.endDate);

        ScreenService.openPopup(widget);
    };

    this.setPeriod = function(widget, DTINI, DTFIM){
        var stripeWidget = templateManager.container.getWidget('stripe');
        var dtIni = moment(DTINI, 'DD/MM/YYYY');
        var dtFim = moment(DTFIM, 'DD/MM/YYYY');
        if (dtFim.diff(dtIni) >= 0){
            widget.startDate = DTINI;
            widget.endDate = DTFIM;
            ScreenService.closePopup();
            this.drillDown(widget, null, 'GROUPS');
            stripeWidget.getField('DTINI').label = widget.startDate;
            stripeWidget.getField('DTFIM').label = widget.endDate;
        }
        else {
            ScreenService.showMessage('A data inicial não pode ser superior à data final.');
        }
    };

    this.setPeriodLabel = function(widget, fieldsWidget) {
        fieldsWidget.newRow();
        fieldsWidget.currentRow.$error = {};
    };

    //---------------------- Nutritional vision

    this.drillDownNutriVision = function(widget, code, nextLevel){
        var stripeWidget = templateManager.container.getWidget('stripe');
        LoginRepository.findOne().then(function (consumerData){
            if (nextLevel === 'GROUPS'){
                GraphingService.getGroupedProductsNutri(consumerData['CDCLIENTE'], consumerData['CDCONSUMIDOR'], widget.startDate, widget.endDate).then(function (groupedProductsNutri){
                    stripeWidget.actions[2].isVisible = false;
                    stripeWidget.actions[3].isVisible = false;
                    if (groupedProductsNutri['ProductGroupNutriRepository'].length){
                        widget.dataSource.data = groupedProductsNutri['ProductGroupNutriRepository'];
                        widget.labelField = 'NMGRUPPROD';
                        widget.valueField = 'QTPRODVEND';
                        widget.nextLevel = "SUBGROUPS";
                        templateManager.updateTemplate();
                    }
                    else{
                        widget.dataSource.data = [];
                        ProductGroupNutriRepository.clearAll();
                    }

                }.bind(this));
            }
            else if (nextLevel === 'SUBGROUPS'){
                GraphingService.getSubgroupsNutri(consumerData['CDCLIENTE'], consumerData['CDCONSUMIDOR'], widget.startDate, widget.endDate, code.CDGRUPPROD).then(function (subgroupsNutri){
                    stripeWidget.actions[2].isVisible = true;
                    stripeWidget.actions[3].isVisible = false;
                    widget.dataSource.data = subgroupsNutri;
                    widget.labelField = 'NMSUBGRPROD';
                    widget.valueField = 'QTPRODVEND';
                    widget.nextLevel = 'PRODUCTS';
                    templateManager.updateTemplate();
                });
            }
            else if (nextLevel === 'PRODUCTS'){
                GraphingService.getProductsNutri(consumerData['CDCLIENTE'], consumerData['CDCONSUMIDOR'], widget.startDate, widget.endDate, code.CDGRUPPROD, code.CDSUBGRPROD).then(function (products){
                    stripeWidget.actions[2].isVisible = false;
                    stripeWidget.actions[3].isVisible = true;
                    widget.dataSource.data = products;
                    widget.labelField = 'NMPRODUTO';
                    widget.valueField = 'QTPRODVEND';
                    widget.nextLevel = null;
                    templateManager.updateTemplate();
                });
            }
        }.bind(this));
    };

    this.setPeriodNutri = function(widget, DTINI, DTFIM){
        var stripeWidget = templateManager.container.getWidget('stripe');
        var dtIni = moment(DTINI, 'DD/MM/YYYY');
        var dtFim = moment(DTFIM, 'DD/MM/YYYY');

        if (dtFim.diff(dtIni) >= 0){
            widget.startDate = DTINI;
            widget.endDate = DTFIM;
            ScreenService.closePopup();
            this.drillDownNutriVision(widget, null, 'GROUPS');
            stripeWidget.getField('DTINI').label = widget.startDate;
            stripeWidget.getField('DTFIM').label = widget.endDate;
        }
        else {
            ScreenService.showMessage('A data inicial não pode ser superior à data final.');
        }
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('GraphingController', GraphingController);
});
