function Utilities(ZHPromise, ScreenService, templateManager, eventAggregator){

    /* ********* CONFIGURATION DETAILS ********* */
    this.frontVersion = null;
    this.appUrl       = null;
    this.logoEmpresa  = null;
    this.logoEmail    = null;
    this.client       = null;
    var isFirstReload = true;
    /* ***************************************** */

    this.setIps = function(clientsField, callback){
        $.getJSON('./config.json', function(json){
            this.frontVersion = json.frontVersion;
            this.appUrl       = json.enderecoSite.replace(/\/+$/,'')+'/';
            this.baseURL      = json.baseURL.replace(/\/+$/,'')+'/';
            this.logoEmpresa  = json.logoEmpresa;
            this.logoEmail    = json.logoEmail;
            this.billetUrl    = json.diretorioBoletos;
            this.client       = json.client;
            templateManager.updateURL(this.baseURL+'backend_vipcantinaecolar/index.php');
            callback(clientsField);
        }.bind(this));
    };

    this.getClientApp = function() {
        return this.client;
    };

    this.getFrontVersion = function() {
        return this.frontVersion;
    }

    eventAggregator.subscribe('onContainerOpen', function(){
        if (isFirstReload){
            ScreenService.openWindow("login");
            isFirstReload = false;
        }
    });

    String.prototype.moneyToFloat = function () {
        var treated = this.replace('R$', '');
        treated = treated.replace(' ', '');
        treated = treated.replace(',', '.');
        return parseFloat(treated);
    };

    Number.prototype.moneyToFloat = function () {
        return parseFloat(this);
    };

    Number.prototype.isInt = function () {
        return this % 1 === 0;
    };

    Number.prototype.toMoney = function () {
        return /*'R$ ' +*/ parseFloat(this).toFixed(2).toString().replace('.',',');
    };

    this.reloadDataSource = function(dataOwner){
        dataOwner.dataSource.reload();
        templateManager.updateTemplate();
    };

    this.hourToMinutes = function(time){
        var hour = time.substring(0, 2);
        var minutes = time.substring(3,5);
        var totalminutes = (hour*60) + parseInt(minutes);
        return totalminutes;
    };

    this.formataDecimal = function(numero){
        if(numero != null){
            numero = numero.replace(",", ".");
        }
        return numero;
    };

    this.cancelarPopUp = function(widget){
        ScreenService.closePopup();
        setTimeout(function(){
            widget.activate();
            templateManager.updateTemplate();
        }, 500);
    };

    this.atualizaTemplate = function(widget){
        widget.reload().then(function(){
        widget.activate();
            templateManager.updateTemplate();
        });
    };

    this.validaNumero = function(NUMERO){
        if(isNaN(NUMERO) || NUMERO == null || NUMERO == ""){
            return false;
        }else{
            return true;
        }
    };

    this.checkEmail = function(email) {
        /* This regular expression is said to not work in some very specific cases, but it appears to be safe to use in our case. */
        var match = email.match(/^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/);
        if (match != null) return true;
        else return false;
    };

    this.asyncOpenWindow = function(widget){
        Util.doAsync(function(){
            ScreenService.openWindow(widget);
        }, 300);
    };

    this.openWindow = function(widget){
        ScreenService.openWindow(widget);
    };

    this.clearField = function(field) {
        if (field.readOnly || field.aclReadOnly) {
            return;
        }
        field.widget.currentRow[field.name] = "";
        for (var prop in field.outData) {
            field.widget.currentRow[field.outData[prop]] = "";
        }
        field.widget.currentRow.changed = true;
        if (field.change) {
            field.change();
        }
    };

    this.removeMaskFromTelephone = function(maskedNumber) {
        if ((maskedNumber.indexOf('(') || maskedNumber.indexOf('(')) != -1) {
            maskedNumber = maskedNumber.replace('(','');
            maskedNumber = maskedNumber.replace(')','');
        }
        if (maskedNumber.indexOf(' ') != -1) {
            maskedNumber = maskedNumber.replace(' ','');
        }
        if (maskedNumber.indexOf('-') != -1) {
            maskedNumber = maskedNumber.replace('-','');
        }

        return maskedNumber;
    };

    this.toggleCheckboxClass = function(widget) {
        var element = document.querySelector('div.header > div > div > div.th.grid-checkbox-column.fixed.ng-scope');
        var selectedClass = ' row-selected';
        if(widget.getCheckedRows().length > 0 && !element.className.includes(selectedClass)){
            element.className += selectedClass;
        } else if(widget.getCheckedRows().length == 0){
            element.className = element.className.replace(selectedClass, '');
        }
    };
    
    this.isValidEmail = function (email) {
		if (email === null || email === "") {
			ScreenService.showMessage("Informe seu e-mail.");
			return false;
		} else {
			/* This regular expression is said to not work in some very specific cases, but it appears to be safe to use in our case. */
			var match = email.match(/^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$/);
			if (match !== null) return true;
			else return false;
		}
	};
	
	this.isValidCPF = function (cpf) {
		/* CPF validation. */
		cpf = cpf.replace('.', '').replace('.', '').replace('-', '');
		var total;
		var first, second;

		var invalidCpfs = [
			"00000000000",
			"11111111111",
			"22222222222",
			"33333333333",
			"44444444444",
			"55555555555",
			"66666666666",
			"77777777777",
			"88888888888",
			"99999999999"
		];

		if (invalidCpfs.indexOf(cpf) === -1) {
			total = 0;
			for (var i = 1; i <= 9; i++) {
				total += parseInt(cpf.substring(i - 1, i)) * (11 - i);
			}
			first = (total * 10) % 11;
			if (first === 10 || first === 11) first = 0;

			total = 0;
			for (var j = 1; j <= 10; j++) {
				total += parseInt(cpf.substring(j - 1, j)) * (12 - j);
			}
			second = (total * 10) % 11;

			if ((second === 10) || (second === 11)) second = 0;
			return !(first !== parseInt(cpf.substring(9, 10)) || second !== parseInt(cpf.substring(10, 11)));
		} else {
			return false;
		}
	};
}

Configuration(function(ContextRegister){
    ContextRegister.register('Utilities', Utilities);
});

